/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;


var logger = Cc["@obm.org/calendar/logger;1"].createInstance(Ci.obmILogger);
var writer = Cc["@obm.org/calendar/writer;1?type=unixfile"].getService(Ci.obmILoggerWriter);
logger.setLevelWriter(this.logger.LOAD_LEVEL, writer);
logger.setHeader("emailNotifications: ");
//logger.debug("new calOBMCalendar()", false, false);


function myObserver() { this.register();} 
myObserver.prototype = {
    observe: function(subject, topic, data) {
       logger.debug("observer: "+topic+":"+data);
       //logger.debug("observer: typeof data : "+typeof data);
    },
    register: function() {
      var observerService = Components.classes["@mozilla.org/observer-service;1"]
                            .getService(Components.interfaces.nsIObserverService);
      observerService.addObserver(this, "email-notifications-window", false);
    },
    unregister: function() {
      var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
                          observerService.removeObserver(this, "email-notifications-window");
    }
}

function openWindow () {
    var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
            .getService(Components.interfaces.nsIWindowWatcher);
    var params = Cc["@mozilla.org/supports-array;1"].createInstance(Ci.nsISupportsArray);
    var win = ww.openWindow(null, "chrome://obm-extension/content/calendar/email-notifications.xul",
            "email-notifications", "chrome,centerscreen", params);
    win.addEventListener('load',
                                function() {
                                            logger.debug("MBA: window load event !");
                            },
                         false);
    
    win.addEventListener('close',
                            function() {
                                logger.debug("MBA: window close event !");
                            },
                         false);
};


var observer = new myObserver();



var module = {
    QueryInterface: function() {return this;},
    openWindow: openWindow
};


// module

var obmEmailNotificationModule = {
	mCID: Components.ID("{b783a1e3-bc6f-430b-8aac-49db02cc7c5e}"),
	mContractID: "@obm.org/calendar/obmEmailNotification;1",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Calendar events emails notification",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return module;
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return module;
}
