function Calendar_Email_Notification_Dialog () {
    var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader);
    var logger =Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
    var writer = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
    logger.setLevelWriter(logger.LOAD_LEVEL, writer);
    logger.setHeader("Calendar_Email_Notification_Dialog: ");
    logger.debug("new Calendar_Email_Notification_Dialog()", false, false);
    
    if (typeof(UtilsOBM) == "undefined") {
        scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
        // to have createDateTime & friends
        scriptLoader.loadSubScript("chrome://calendar/content/calUtils.js");
    }
    
    if ( typeof createDateTime == "undefined") {
        scriptLoader.loadSubScript("chrome://calendar/content/calUtils.js");
        //logger.debug("loaded calUtils");
    }
    
    
    // item : calendar event item
    // action : "added", "updated", "removed"
    // olditem: in case of action == "updated", the old state of the item
    this.handleNotification = function(item, action, oldItem) {
        
        if ( ! item instanceof Components.interfaces.calIEvent ) {
            logger.debug("item is not an event: no notification widget",false,false);
            return ;
        }
        
        // don't even think of notifying events older than 6 months
        // Compat with utilsOBM => purge
	var d = new Date();
	var dd = new Date(d.getFullYear(), d.getMonth() - 6, d.getDay(), d.getHours());
	var rangeEnd = createDateTime();
	rangeEnd = jsDateToDateTime(dd, calendarDefaultTimezone());

        if (  item.startDate.compare(rangeEnd) < 0) {
            logger.debug("compare event date before rangeEnd",false,false);
            return ;
        }
        
        
        if ( action === "added" ) {
            // only one attendee : don't send email to self
            var foo = {};
            logger.debug("attendees : "+ item.getAttendees(foo).length,false,false);
            if ( item.getAttendees(foo).length == 0 ) {
                logger.debug("only one attendee in item : no notification widget",false,false);
                return ;
            }
        }

        var pref = UtilsOBM.getCharPref("extensions.obm.sendNotifications", "ask");
        if ( pref == "always" ) {
            //logger.debug("setting notification to true from user preferences",false,false);
            UtilsOBM.setNotificationStatus(item.calendar, item,action,true);
            return;
        } else if ( pref == "never" ) {
            //logger.debug("setting notification to false from user preferences",false,false);
            UtilsOBM.setNotificationStatus(item.calendar, item,action,false);
            return;
        }
        
        this.openWindow(item,action);
        
    };
    
    /*
     opens a new email notification window asking user if emails should be sent
     for the current notification
    */
    this.openWindow = function ( aItem, action ) {
        var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
            .getService(Components.interfaces.nsIWindowWatcher);
        var paramBlock = Components.classes["@mozilla.org/embedcomp/dialogparam;1"]
            .createInstance(Components.interfaces.nsIDialogParamBlock);

        paramBlock.SetNumberStrings(4);
        paramBlock.SetString(0, aItem.calendar.id);
        paramBlock.SetString(1, aItem.id);
        paramBlock.SetString(2, aItem.title);
        paramBlock.SetString(3, action);
        
        var windowName = "notificationDialog:"+aItem.id;
        
        var win = ww.openWindow(null, "chrome://obm-extension/content/calendar/email-notifications.xul",
            windowName, "chrome,centerscreen", paramBlock);
    };
    
};