/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - 2009-2011 Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */

/* ======================== the vcard bar  */

function OBM_MessagePane_OnLoad() {

	// add a listener called when a message is displayed
    gMessageListeners.push({
		onStartHeaders: function () {},
		onEndHeaders: function () {
			mLogger.debug("OBM_MessagePane_OnLoad  onEndAttachments ", false, false);
			document.getElementById("obm-vcard-bar").checkAndActivate(msgWindow, gDBView);
		},
		onEndAttachments : function () { // not called in TB2
		}
	});

    // We need to extend the HideMessageHeaderPane function to also hide the
    // message header pane. Otherwise, the bar will still be shown when
    // changing folders.
    OBM_MessagePane_OnLoad.OrignalHideMessageHeaderPane = HideMessageHeaderPane;
    HideMessageHeaderPane = function OBM_HideMessageHeaderPane() {
        document.getElementById("obm-vcard-bar").collapsed = true;
        OBM_MessagePane_OnLoad.OrignalHideMessageHeaderPane.apply(null, arguments);
    };	
}

/**
 * Unload handler to clean up after the bar
 */
function OBM_MessagePane_OnUnLoad() {
    removeEventListener("messagepane-loaded", OBM_MessagePane_OnLoad, true);
    removeEventListener("messagepane-unloaded", OBM_MessagePane_OnUnLoad, true);
}

window.addEventListener("messagepane-loaded", OBM_MessagePane_OnLoad, true);
window.addEventListener("messagepane-unloaded", OBM_MessagePane_OnUnLoad, true);	
