/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const HTML_NS = "http://www.w3.org/1999/xhtml";
const Ci = Components.interfaces;

var currentUL = null;
var currentLI = null;
var currentH2 = null;

var stringBundle;

var obs = null;

function getLocalizedMessage(aString) {
	dump(""+aString+"\n");
	try {
		return stringBundle.GetStringFromName("obm.sync."+aString);
	} catch(e) {
		return aString;
	}
}

function notifyBeforeClosing(aParam) {
	var label = document.documentElement.getButton("accept").label;
	regExp = /\(\d\d*\)/;
	if ( label.search(regExp) != -1 ) {
		label = label.replace(regExp, '(' + aParam.decount + ')');
	} else {
		label += " (" + aParam.decount + ")";
	}
	document.documentElement.getButton("accept").label = label;
	if ( aParam.decount<0 ) {
		window.close();
	}
	aParam.decount--;
}

function done(aSuccess) {
	var tb = document.getElementById("mainThrobber");
	tb.style.visibility= "collapse";
	if (aSuccess) {
		var ll = document.getElementById("resultLabel");
		ll.style.visibility = "visible";
	}
	window.enableAccept();
	if (aSuccess) {
		// Automatically close the window after 3 seconds
  	this.decount=3;
  	notifyBeforeClosing(this);
  	setInterval(notifyBeforeClosing, 1000, this);
	}
}

function SyncObserver() {}
SyncObserver.isSecondPass = false;
SyncObserver.prototype = {
	observe: function(subject, topic, data) {
		switch(data) {
			case "newOperation":
				var opName = subject.wrappedJSObject.opName;
				
				switch(opName) {
					case "logUserIn":
					this.curOpName = "login";
						document.getElementById(this.curSet+"Status").value = getLocalizedMessage(this.curOpName) + " ...";
						break;
					case "getSync":
						this.curOpName = "checking";
						break;
					case "mergeRemoteDiff":
						this.curOpName = "merging";
						document.getElementById(this.curSet+"Status").value = getLocalizedMessage(this.curOpName) + " ...";
						break;
					case "sendLocalDiff":
						this.curOpName = "sending";
						break;
					case "listCategories":
						this.curOpName = "merging";
						break;
					default :
				}
				break;
			case "operationDone":
				document.getElementById(this.curSet+"Status").value = "";
				break;
			case "newOperationSet":
				var msg = subject.wrappedJSObject;
				this.curSet = msg.opSetName;
				document.getElementById(this.curSet+"Box").setAttribute("hidden", false);
				break;
			case "operationSetError":
				var msg = subject.wrappedJSObject.message;
				document.getElementById(this.curSet+"Status").value = msg;
				break;
			case "operationSetErrorFatal":
				var msg = subject.wrappedJSObject.message;
				
				if ( this.curSet == "cal" ) {
					var widget = document.getElementById(this.curSet+"StatusError");
					document.getElementById("progressBox").firstChild.style.display="none";
					widget.appendChild( document.createTextNode(msg) );
					widget.style.color="red";
					widget.style.display="block";
					
				} else {
					document.getElementById(this.curSet+"Status").value = msg;
					document.getElementById(this.curSet+"Status").style.color = "red";
				}
				done(false);
				break;
			case "operationSetDone":
				document.getElementById(this.curSet+"Status").value = "ok";
				break;
			case "syncDone":
				done(true);
				break;
			case "operationProgress":
				var msg = subject.wrappedJSObject;
				document.getElementById(this.curSet+"Name").value = msg.entity;
				document.getElementById(this.curSet+"Status").value = 
					getLocalizedMessage(this.curOpName) +" : " + msg.idx + "/" + msg.total + " " + getLocalizedMessage(msg.type) +" ...";
				dump(this.curOpName +" : " + msg.idx + "/" + msg.total + " " + msg.type +" ...\n");
				break;
			default:
		}
	},
	register: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, "verbose-obm-sync-progress", false);
	},
	unregister: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this, "verbose-obm-sync-progress");
	}
}

function synchronizeAll() {
	var syncManager = Components.classes["@obm.org/syncmanager;1"].createInstance(Components.interfaces.obmISyncManager);
	syncManager.syncAll();
}

function onStart() {
	obs = new SyncObserver();
	obs.register();
	stringBundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
     	.getService(Components.interfaces.nsIStringBundleService)
     	.createBundle("chrome://obm-extension/locale/calendar/errors_warnings.properties");
	var ll = document.getElementById("resultLabel");
	ll.style.visibility = "collapse";
	setTimeout(synchronizeAll, 100);   	
}

function onUnload() {
	obs.unregister();
}

window.addEventListener("load", onStart, false);
window.addEventListener("unload", onUnload, false);
